import java.awt.*;
import java.awt.event.*;

class PopupMenuDemo
{
	public static void main(String args[])
	{
		new MainWindow();
	}
}

class MainWindow extends Frame
{
	PopupMenu p_menu;

	// |bvAbvj[p̃x
	final String LARGE = "Larger";
	final String SMALL = "Smaller";
	final String EXIT = "Exit";

	// ƎbZ[W
	final int WINDOW_LARGE = 2000;
	final int WINDOW_SMALL = 2001;

	// TCY̒`
	final Dimension LARGER_SIZE = new Dimension(500,500);
	final Dimension SMALLER_SIZE = new Dimension(100,100);

	// RXgN^
	public MainWindow()
	{
		super("Popup Menu Test");
		setSize(255,255);

		// EChECxg\ɂ
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);

		// |bvAbvj[̍\z
		p_menu = new PopupMenu();
		MenuItem item = new MenuItem(LARGE);
		item.setActionCommand(LARGE);
		p_menu.add(item);

		item = new MenuItem(SMALL);
		item.setActionCommand(SMALL);
		p_menu.add(item);

		p_menu.addSeparator();

		item = new MenuItem(EXIT);
		item.setActionCommand(EXIT);
		p_menu.add(item);

		// |bvAbvj[̃ANVXi̒`
		ActionListener action_listener = new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				String command = e.getActionCommand();
				if(command == LARGE)
				{
					dispatchEvent(new WindowEvent(MainWindow.this,WINDOW_LARGE));
				}
				else if(command == SMALL)
				{
					dispatchEvent(new WindowEvent(MainWindow.this,WINDOW_SMALL));
				}
				else if(command == EXIT)
				{
					System.exit(0);
				}
			}
		};
		p_menu.addActionListener(action_listener);

		// }EXXi̒`
		MouseListener mouse_listener = new MouseAdapter()
		{
			public void mousePressed(MouseEvent e)
			{
				// E{^ꂽA|bvAbvj[\
				if(e.getModifiers() == InputEvent.BUTTON3_MASK)
					p_menu.show(MainWindow.this,e.getX(),e.getY());
			}
		};
		addMouseListener(mouse_listener);

		add(p_menu);
		setVisible(true);
	}

	// EChECxg̏
	protected void processWindowEvent(WindowEvent e)
	{
		if(e.getID() == WINDOW_LARGE)
		{
			this.setSize(LARGER_SIZE);
		}
		else if(e.getID() == WINDOW_SMALL)
		{
			this.setSize(SMALLER_SIZE);
		}
		else if(e.getID() == WindowEvent.WINDOW_CLOSING)
		{
			System.exit(0);
		}
	}
}